import { randomIntInRange } from '../utils/Random';

export interface SourceNumber {
  sourceNum: number | undefined;
}

function selectSource(memory: SourceNumber) {
  if (memory.sourceNum === undefined) {
    const sources = creep.room.find(FIND_SOURCES);
    memory.sourceNum = randomIntInRange(0, sources.length);
  }
}

function moveToSource(creep: Creep) {
  const memory = creep.memory as SourceNumber;
  const sources = creep.room.find(FIND_SOURCES);
  const sourceNum = memory.sourceNum;
  if (creep.harvest(sources[sourceNum]) == ERR_NOT_IN_RANGE) {
    creep.say('🔄 harvest ' + sourceNum);
    creep.moveTo(sources[sourceNum], { visualizePathStyle: { stroke: '#ffaa00' } });
  }
}
